﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public Game game;

        private int fieldsize = 25;//Gamebox is 500x500pixels

        protected override void OnPaint(PaintEventArgs e)
        {
            DrawField(e.Graphics);
            DrawPlayer(e.Graphics);
            base.OnPaint(e);
        }

        #region Draw
        private void DrawPlayer(Graphics g)
        {
            List<Point> points = new List<System.Drawing.Point>();
            switch (game.lerak.angle)
            { 
                case Player.Angles.Right:
                    points.Add (new Point (game.lerak.x * fieldsize,game.lerak.y * fieldsize));
                    points.Add(new Point(game.lerak.x * fieldsize, (game.lerak.y * fieldsize)+fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + fieldsize, (game.lerak.y  * fieldsize)+(fieldsize/2)));
                    break;
                case Player.Angles.Down:
                    points.Add(new Point(game.lerak.x * fieldsize, game.lerak.y * fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + fieldsize, game.lerak.y * fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + (fieldsize/2), (game.lerak.y * fieldsize) + fieldsize));
                    break;
                case Player.Angles.Up:
                    points.Add(new Point((game.lerak.x * fieldsize), (game.lerak.y * fieldsize)+fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + fieldsize, (game.lerak.y * fieldsize)+fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + (fieldsize / 2), (game.lerak.y * fieldsize)));
                    break;
                case Player.Angles.Left:
                    points.Add(new Point((game.lerak.x * fieldsize)+  fieldsize, game.lerak.y * fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize) + fieldsize, (game.lerak.y * fieldsize) + fieldsize));
                    points.Add(new Point((game.lerak.x * fieldsize), (game.lerak.y * fieldsize) + (fieldsize/2)));
                    break;
                default: break;
            
            }
            g.FillPolygon(new SolidBrush(Color.Yellow), points.ToArray());
        }
        private void DrawField(Graphics g)
        {
            for (int y = 0; y < 20; y++)
            {
                for (int x = 0; x < 20; x++)
                {
                    Brush fieldbrush = new SolidBrush(Color.Pink);
                    switch (game.playfield.GetField(x, y))
                    {
                        case Playfield.Type.Path: fieldbrush = new SolidBrush(Color.Blue);
                            break;
                        case Playfield.Type.Wall: fieldbrush = new SolidBrush(Color.Red);
                            break;
                        case Playfield.Type.Hole: fieldbrush = new SolidBrush(Color.Yellow);
                            break;
                        case Playfield.Type.Treasure: fieldbrush = new SolidBrush(Color.Green);
                            break;
                        case Playfield.Type.Mover: fieldbrush = new SolidBrush(Color.Cyan);
                            break;
                        default: 
                            break;
                    
                    }
                    Rectangle rect = new Rectangle(new Point(x * fieldsize, y * fieldsize), new Size(fieldsize, fieldsize));
                    g.FillRectangle(fieldbrush, rect);

                }
            }

        }
        #endregion



        List<Game.Actions> actions_remain = new List<Game.Actions>();


        private void ShowStep(Game.Actions a)
        {
            switch (a)
            { 
                case Game.Actions.rotate_right:
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.angle = Player.Angles.Down;
                    else if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.angle = Player.Angles.Left;
                    else if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.angle = Player.Angles.Up;
                    else if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.angle = Player.Angles.Right;
                    break;
                case Game.Actions.rotate_left:
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.angle = Player.Angles.Up;
                    else if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.angle = Player.Angles.Left;
                    else if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.angle = Player.Angles.Down;
                    else if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.angle = Player.Angles.Right;
                    break;
                case Game.Actions.forward_one:
                    if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.y++;
                    if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.y--;
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.x++;
                    if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.x--;
                    break;
                case Game.Actions.backward:
                    if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.y--;
                    if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.y++;
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.x--;
                    if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.x++;
                    break;
                case Game.Actions.forward_two:
                    if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.y+=2;
                    if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.y -= 2;
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.x += 2;
                    if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.x -= 2;
                    break;
                case Game.Actions.forward_three:
                    if (game.lerak.angle == Player.Angles.Down)
                        game.lerak.y += 3;
                    if (game.lerak.angle == Player.Angles.Up)
                        game.lerak.y -= 3;
                    if (game.lerak.angle == Player.Angles.Right)
                        game.lerak.x += 3;
                    if (game.lerak.angle == Player.Angles.Left)
                        game.lerak.x -= 3;
                    break;
                default: break;
            
            
            }

        }


        private void OnInitComplete()
        {
            ShowAllowedActions();
            this.Invalidate();
            
        }
        private void OnStep()
        {
            ShowAllowedActions();
            this.Invalidate();
        }

        private void ShowAllowedActions()
        {
            combo_actions.SelectedIndex = 0;
            foreach (Game.Actions a in game.allowed_actions)
                actions_remain.Add(a);
            btn_add_action.Enabled = true;
            game.actions.Clear();
            listBox1.Items.Clear();
            label1.Text = "Vybrano 0 z 5 kroků";
           
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            game.OnInitComplete += new Game.InitCompleteHandler(OnInitComplete);
            game.OnStep += new Game.StepHandler(OnStep);

            game.Init();
        }


        private void button1_Click(object sender, EventArgs e)
        {
            game.MakeStep();

        }



        private void btn_add_action_Click(object sender, EventArgs e)
        {
            if ((9 - actions_remain.Count) == 5)
                return;
            int index = 0;
            foreach (Game.Actions a in actions_remain)
            {
                if (a == IndextoAction(combo_actions.SelectedIndex))
                {
                    actions_remain.RemoveAt(index);
                    break;
                }
                index++;
            }
            game.actions.Add(IndextoAction(combo_actions.SelectedIndex));
            int oldindex = combo_actions.SelectedIndex;
            combo_actions.SelectedIndex = 0;
            combo_actions.SelectedIndex = oldindex;
            label1.Text = "Vybrano " + (9 - actions_remain.Count) + " z 5 kroku";

            listBox1.Items.Add (Action.ActiontoString(IndextoAction(combo_actions.SelectedIndex)));
            ShowStep(IndextoAction(combo_actions.SelectedIndex));
            this.Invalidate();
        }

        private void combo_actions_SelectedIndexChanged(object sender, EventArgs e)
        {
            btn_add_action.Enabled = true;
            if (!actions_remain.Contains(IndextoAction(combo_actions.SelectedIndex)))
            {
                txt_action_status.Text = "Tato akce ted neni povolena !";
                btn_add_action.Enabled = false;
                return;
            }
            if (CountActionRemains(IndextoAction(combo_actions.SelectedIndex)) <= 0)
            {
                txt_action_status.Text = "Tuto akci jiz nelze pouzit !";
                btn_add_action.Enabled = false;
                return;
            }
            txt_action_status.Text = "Tato akce zbyva: " + CountActionRemains(IndextoAction(combo_actions.SelectedIndex)) + "x";
            btn_add_action.Enabled = true;
            

        }

        private Game.Actions IndextoAction(int i)
        {
            switch (i)
            {
                case 0: return Game.Actions.forward_one;
                case 1: return Game.Actions.forward_two;
                case 2: return Game.Actions.forward_three;
                case 3: return Game.Actions.rotate_right;
                case 4: return Game.Actions.rotate_left;
                case 5: return Game.Actions.backward;
                default :return Game.Actions.error;
            }

        }

        private int CountActionRemains(Game.Actions a)
        {
            int count = 0;
            foreach (Game.Actions b in actions_remain)
            {
                if (a == b) count++;
            }
            return count;
        }

        private void btn_remove_action_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedIndex == -1)
                return;
            Game.Actions a = Action.StringtoAction(listBox1.Items[listBox1.SelectedIndex].ToString());
            actions_remain.Add(a);
            game.actions.Remove(a);
            int oldindex = combo_actions.SelectedIndex;
            combo_actions.SelectedIndex = 0;
            combo_actions.SelectedIndex = oldindex;

        }

    }
}
