﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Text;

namespace WindowsFormsApplication1
{
    public class Game
    {
        private string BaseAdress = "http://localhost:8000";//Default
        private string GameID = "";

        public  Player lerak = new Player();
        public  Playfield playfield = new Playfield();

        public Actions[] allowed_actions = new Actions[9];
        public List<Actions> actions = new List<Actions>();//Actions added for server request

        public Game(string _addr, string _port)
        {           
            BaseAdress = _addr + ":" + _port;
        }

        public enum Actions //Possible actions to take
        {
         forward_one,
         forward_two,
         forward_three,
         rotate_left,
         rotate_right,
         backward,
         error
        }


        public void MakeStep()//Tell server what player did and get pitch updates
        {
            bool error = false;
            foreach (Actions a in actions)
            {
                if (!allowed_actions.Contains(a))
                    error = true;
            }
            if (actions.Count() != 5)
                return;
            if (error)
                return;
          string requrl = BaseAdress + "/kolo?id=" + GameID + "&pohyby=" + Action.ActionListtoString(actions.ToArray());
          string response = new Request(requrl).Fetch();
          ServerCallback(response);
        }

        public delegate void InitCompleteHandler();
        public event InitCompleteHandler OnInitComplete;

        public delegate void StepHandler();
        public event StepHandler OnStep;

        //Ask server for pitch, get game session
        public void Init()
        {
           string response =  new Request(BaseAdress + "/start").Fetch().ToUpper();
           ServerCallback(response, true);
        }

        //Server answered our query
        public void ServerCallback(string data, bool init = false)
        {
         
            string[] lines = data.Split("\n".ToCharArray());
            int temp = 0;
            if (!int.TryParse (lines[0],out temp))
            {
                System.Windows.Forms.MessageBox.Show(data);
                return;
            }

            int lineid = 0;

            string plain_playfield = "";

            foreach (string line in lines)
            {
                if (lineid == 0)                
                    GameID = (init) ? (int.Parse(line)).ToString() : GameID;//Game id is not set               
                    else if (lineid <= 20)//These lines contains pitch data
                        if (line != "")
                            plain_playfield += line + "\n";
                lineid++;
            }
            playfield = Playfield.CreateFromString(plain_playfield);
            lerak = Player.PlayerFromString(lines[lines.Count() - 3]);
            allowed_actions = Action.StringtoActionList(lines[lines.Count() - 2]);//Parse action which can user take
            if (init)//Tell form to redraw
                OnInitComplete();
            else
                OnStep();
        }

/*
1233LLRRZ
*/

    }
}
