﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace WindowsFormsApplication1
{
    public class Player
    {
        public int x, y;
        public Angles angle;

        public enum Angles
        { 
            Up,
            Down,
            Left, 
            Right        
        }

        public static Player PlayerFromString(string plain_player)//Parse player info from string
        {
            Regex r_player = new Regex(@"(?<x>\d)\s(?<y>\d)\s(?<rotation>\w)");
            if (r_player.IsMatch(plain_player))
            {
                Player p = new Player();

                Match m = r_player.Match(plain_player);
                int x = int.Parse(m.Groups["x"].Value);
                int y = int.Parse (m.Groups["y"].Value);
                string rotation = m.Groups["rotation"].Value;

                p.x = x - 1;//Server output coords starts from 1
                p.y = y - 1;

                switch (rotation.ToUpper())
                {
                    case "N": p.angle = Angles.Up;
                        break;
                    case "R": p.angle = Angles.Right;
                        break;
                    case "D": p.angle = Angles.Down;
                        break;
                    case "L": p.angle = Angles.Left;
                        break;
                    default: 
                        break;

                }
                return p;
            }            
            return null;//An error ocured in server...
        }

    }
}
