﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace WindowsFormsApplication1
{
    public class Playfield
    {

        private Type[,] field = new Type[20,20];

        public void SetField(int x, int y, Type value)
        {
            field[x, y] = value;
        }

        public Type GetField(int x, int y)
        {
            return field[x, y];       
        }

        public enum Type 
        {
            Path,
            Wall,
            Hole,
            Treasure,
            Mover
        }

        public static Playfield CreateFromString(string plain_playfield)//Translate string to array of enums
        {
            Playfield p = new Playfield();
            int x = 0, y = 0;
            string[] lines = plain_playfield.Split("\n".ToCharArray());
            foreach (string line in lines)
            {
                if (line == "" || line == string.Empty || line == null)//Skip empty lines
                    continue;
                x = 0;
            
                foreach (char c in line)
                {
                    if (x > 19) continue;
                    string s = c.ToString();
                    switch (s)
                    {
                        case ".":
                            p.field[x, y] =  Playfield.Type.Path;
                            break;
                        case "X":
                             p.field[x, y] =  Playfield.Type.Wall;
                            break;
                        case "#":
                             p.field[x, y] =  Playfield.Type.Hole;
                            break;
                        case "$":
                             p.field[x, y] =  Playfield.Type.Treasure;
                            break;
                        default:
                            break;
                    }
                    x++;
                }
                y++;

            }

            return p;
        }

    }
}
